/**
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
import React from 'react';
import PropTypes from 'prop-types';

function ContextMenuGroup(_ref) {
  var label = _ref.label,
      children = _ref.children;
  return /*#__PURE__*/React.createElement("li", {
    role: "none"
  }, /*#__PURE__*/React.createElement("ul", {
    role: "group",
    "aria-label": label
  }, children));
}

ContextMenuGroup.propTypes = {
  /**
   * Specify the children of the ContextMenuGroup
   */
  children: PropTypes.node,

  /**
   * Rendered label for the ContextMenuGroup
   */
  label: PropTypes.node.isRequired
};
export default ContextMenuGroup;