"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

var _react = _interopRequireDefault(require("react"));

var _ContextMenu = _interopRequireWildcard(require("../ContextMenu"));

var _enzyme = require("enzyme");

var _carbonComponents = require("@rocketsoftware/carbon-components");

var _windowOrGlobal = require("window-or-global");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
var prefix = _carbonComponents.settings.prefix;
(0, _windowOrGlobal.describe)('ContextMenu', function () {
  (0, _windowOrGlobal.describe)('renders as expected', function () {
    (0, _windowOrGlobal.describe)('menu', function () {
      it('receives the expected classes when closed', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.default, null));
        var container = wrapper.childAt(0).childAt(0);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu"))).toBe(true);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu--open"))).toBe(false);
      });
      it('receives the expected classes when opened', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.default, {
          open: true
        }));
        var container = wrapper.childAt(0).childAt(0);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu"))).toBe(true);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu--open"))).toBe(true);
      });
    });
    (0, _windowOrGlobal.describe)('option', function () {
      it('receives the expected classes', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Copy"
        }));
        var container = wrapper.childAt(0).childAt(0);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu-option"))).toBe(true);
      });
      it('renders props.label', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Copy"
        }));
        (0, _windowOrGlobal.expect)(wrapper.find("span.".concat(prefix, "--context-menu-option__label")).text()).toBe('Copy');
        (0, _windowOrGlobal.expect)(wrapper.find("span.".concat(prefix, "--context-menu-option__label")).prop('title')).toBe('Copy');
      });
      it('renders props.shortcut when provided', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Copy",
          shortcut: "\u2318C"
        }));
        (0, _windowOrGlobal.expect)(wrapper.find("div.".concat(prefix, "--context-menu-option__info")).length).toBeGreaterThan(0);
        (0, _windowOrGlobal.expect)(wrapper.find("div.".concat(prefix, "--context-menu-option__info")).text()).toBe('⌘C');
      });
      it('respects props.disabled', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Copy",
          disabled: true
        }));
        var content = wrapper.find("div.".concat(prefix, "--context-menu-option__content"));
        (0, _windowOrGlobal.expect)(content.hasClass("".concat(prefix, "--context-menu-option__content--disabled"))).toBe(true);
        (0, _windowOrGlobal.expect)(wrapper.find("li.".concat(prefix, "--context-menu-option")).prop('aria-disabled')).toBe(true);
      });
      it('supports danger kind', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Delete",
          kind: "danger"
        }));
        var option = wrapper.find(".".concat(prefix, "--context-menu-option"));
        (0, _windowOrGlobal.expect)(option.hasClass("".concat(prefix, "--context-menu-option--danger"))).toBe(true);
      });
      it('ignores danger kind when it has children', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.default, null, /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Remove",
          kind: "danger"
        }, /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Move to trash"
        }), /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Delete"
        }))));
        var option = wrapper.find(".".concat(prefix, "--context-menu-option")).at(0);
        (0, _windowOrGlobal.expect)(option.hasClass("".concat(prefix, "--context-menu-option--danger"))).toBe(false);
      });
      it('renders props.children as submenu', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.default, null, /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Format"
        }, /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Bold"
        }), /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuItem, {
          label: "Italic"
        }))));
        var level1 = wrapper.find("li.".concat(prefix, "--context-menu-option")).at(0);
        (0, _windowOrGlobal.expect)(level1.find("ul.".concat(prefix, "--context-menu")).length).toBeGreaterThan(0);
      });
    });
    (0, _windowOrGlobal.describe)('radiogroup', function () {
      it('children have role "menuitemradio"', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuRadioGroup, {
          label: "Share with",
          items: ['None', 'All']
        }));
        var options = wrapper.find("li.".concat(prefix, "--context-menu-option"));
        (0, _windowOrGlobal.expect)(options.every('li[role="menuitemradio"]')).toBe(true);
      });
    });
    (0, _windowOrGlobal.describe)('selectable', function () {
      it('has role "menuitemcheckbox"', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuSelectableItem, {
          label: "Publish"
        }));
        var container = wrapper.childAt(0);
        (0, _windowOrGlobal.expect)(container.prop('role')).toBe('menuitemcheckbox');
      });
    });
    (0, _windowOrGlobal.describe)('divider', function () {
      it('receives the expected classes', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuDivider, null));
        var container = wrapper.childAt(0);
        (0, _windowOrGlobal.expect)(container.hasClass("".concat(prefix, "--context-menu-divider"))).toBe(true);
      });
      it('has role "separator"', function () {
        var wrapper = (0, _enzyme.mount)( /*#__PURE__*/_react.default.createElement(_ContextMenu.ContextMenuDivider, null));
        var container = wrapper.childAt(0);
        (0, _windowOrGlobal.expect)(container.prop('role')).toBe('separator');
      });
    });
  });
});