"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _ContextMenuGroup = _interopRequireDefault(require("./ContextMenuGroup"));

var _ContextMenuRadioGroupOptions = _interopRequireDefault(require("./ContextMenuRadioGroupOptions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Copyright IBM Corp. 2020
 *
 * This source code is licensed under the Apache-2.0 license found in the
 * LICENSE file in the root directory of this source tree.
 */
function ContextMenuRadioGroup(_ref) {
  var items = _ref.items,
      initialSelectedItem = _ref.initialSelectedItem,
      label = _ref.label,
      _ref$onChange = _ref.onChange,
      onChange = _ref$onChange === void 0 ? function () {} : _ref$onChange;
  return /*#__PURE__*/_react.default.createElement(_ContextMenuGroup.default, {
    label: label
  }, /*#__PURE__*/_react.default.createElement(_ContextMenuRadioGroupOptions.default, {
    items: items,
    initialSelectedItem: initialSelectedItem,
    onChange: onChange
  }));
}

ContextMenuRadioGroup.propTypes = {
  /**
   * Whether the option should be checked by default
   */
  initialSelectedItem: _propTypes.default.string,

  /**
   * Array of the radio options
   */
  items: _propTypes.default.arrayOf(_propTypes.default.string).isRequired,

  /**
   * The radio group label
   */
  label: _propTypes.default.string.isRequired,

  /**
   * Callback function when selection the has been changed
   */
  onChange: _propTypes.default.func
};
var _default = ContextMenuRadioGroup;
exports.default = _default;